<template>
  <BasicModal v-bind="$attrs" @register="registerModal" @ok="handleSubmit" :title="title" width="50%" :height="460">
    <BasicForm @register="registerForm" style="height:360px"> </BasicForm>
  </BasicModal>
</template>
<!-- 预受理 -->
<script lang="ts" setup>
  import { ref, unref } from 'vue';
  import { FormSchema } from '/@/components/Table';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form/index';
  import { submiYsl, findYsl } from '/@/api/common/api';
  import { useMessage } from '/@/hooks/web/useMessage';
  import dayjs from 'dayjs';
  // Emits声明

  const emit = defineEmits(['register', 'success']);
  const { createMessage } = useMessage();
  const isUpdate = ref(true);
  const AdviceFormSchema: FormSchema[] = [
    { label: '污染地块ID', field: 'wrdkid', component: 'Input', show: false },
    { label: '所处阶段编码', field: 'scjdbm', component: 'Input', show: false },
    { label: 'pgtype', field: 'pgtype', component: 'Input', show: false },
    {
      label: '接受材料时间',
      field: 'clsj',
      component: 'DatePicker',
      required: true,
      componentProps: {
        format: 'YYYY-MM-DD',
        valueFormat: 'YYYY-MM-DD',
      },
    },
    {
      label: '备注',
      field: 'clyj',
      component: 'InputTextArea',
      componentProps: {
        rows: 5,
      },
    },
    {
      label: '相关材料',
      field: 'clyjfj',
      component: 'JUpload',
      componentProps: {
        showUploadList: false,
        accept: '.pdf,.zip',
        fileName: '预受理材料',
        beforeUpload: (file) => {
          let isshow = false;
          const isFile = file.name.split('.')[file.name.split('.').length - 1];
          if (isFile == 'pdf' || isFile == 'zip' || isFile == 'PDF') {
            isshow = true;
          } else {
            createMessage.error('只能上传.pdf/.zip格式的文件');
            isshow = false;
          }
          return isshow;
        },
      },
    },
  ];
  //表单配置
  const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    labelWidth: 220,
    schemas: AdviceFormSchema,
    showActionButtonGroup: false,
  });
  //表单赋值
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    //重置表单
    await resetFields();
    setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });
    isUpdate.value = !!data?.isUpdate;
    if (unref(isUpdate)) {
      //表单赋值
      await setFieldsValue({
        ...data.record,
      });
      const res = await findYsl({ wrdkid: data.record.wrdkid, scjdbm: data.record.scjdbm, pgtype: data.record.pgtype });
      const obj = {
        wrdkid: res.wrdkid,
        scjdbm: res.scjdbm,
        clsj: res.tsamp,
        clyj: res.bz,
        clyjfj: res.xgcl,
      };
      if (res) {
        // 如果有值代表已经填写过了
        await setFieldsValue({
          ...obj,
        });
        setModalProps({ confirmLoading: false, showCancelBtn: false, showOkBtn: false });
      }
    }
  });
  //设置标题
  const title = ref('预受理');
  //表单提交事件
  async function handleSubmit() {
    try {
      let values = await validate();
      values.clsj = values.clsj + ' ' + dayjs().format('HH:mm:ss');
      dayjs().format('HH:mm:ss');
      setModalProps({ confirmLoading: true });
      //提交表单
      await submiYsl(values);
      //关闭弹窗
      closeModal();
      emit('success');
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>

<style >
/* .ant-modal-body{
  min-height: 400px;
} */
.ant-form .ant-row{
  height: 100%;
}
</style>
